﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using FCS.Common;
using FCS.Crawler.Basketball;
using FCS.Crawler.ZCLotteryAgainst;
using FCS.Crawler.ZCLotteryAsianDish;
using FCS.Crawler.ZCLotteryGames;
using FCS.Crawler.ZCLotteryGrouping;
using FCS.Crawler.ZCLotteryIP;
using FCS.Crawler.ZCLotteryMatchs;
using FCS.Crawler.ZCLotteryScore;
using FCS.Crawler.ZCLotterySizeIndex;
using FCS.Interface;
using FCS.Models;
using Quartz;

namespace FCS.Crawler
{
    public class UpdateJob : CommonJob, IJob
    {
        public UpdateJob()
        {
            logName = "UpdateJob";
        }
        public void Execute(IJobExecutionContext context)
        {
            Config = CommonHelper.GetConfigFromDataMap(context.JobDetail.JobDataMap);
            Click();
        }

        public void Click()
        {
            ThreadPool.SetMaxThreads(200, 200);
            CommonHelper.LogBD("Update开始", logName);
            new IPJob().GetIP();
            Task.Run(() =>
            {
                new FootballMatchJob().GetAll();
                new GroupingJob().Click();
            });
            Task.Run(() =>
            {
                new B_GroupingJob().Click();
                new B_GamesJob().Click();
                new B_PlayersStatisticsJob().Click();
            });
            CommonHelper.LogBD("Update结束", logName);
        }
    }

}
