﻿using System;

namespace FCS.Models
{
    //F_Compensate
    /// <summary>
    /// 欧赔详情
    /// </summary>
    [Table("F_Compensate")]
    public class F_Compensate
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 胜赔率
        /// </summary>
        /// <returns></returns>
        public double? SOdd { get; set; }
        /// <summary>
        /// 平赔率
        /// </summary>
        /// <returns></returns>
        public double? POdd { get; set; }
        /// <summary>
        /// 负赔率
        /// </summary>
        /// <returns></returns>
        public double? FOdd { get; set; }
        /// <summary>
        /// true：主对，false：客队
        /// </summary>
        /// <returns></returns>
        public bool IsHomeTeamScore { get; set; }
        /// <summary>
        /// 类型（枚举）概率、凯利指数、即时赔率、返还率等
        /// </summary>
        /// <returns></returns>
        public string CompensateType { get; set; }
        /// <summary>
        /// 盘口公司
        /// </summary>
        /// <returns></returns>
        public string BankerCompanyId { get; set; }
        /// <summary>
        /// 比赛编码
        /// </summary>
        /// <returns></returns>
        public string GameId { get; set; }
        /// <summary>
        /// 变化时间
        /// </summary>
        /// <returns></returns>
        public DateTime? ChangeDateTime { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
    }
}