﻿using System;

namespace FCS.Models
{
    //纪录比赛的等分，，以及红牌等信息
    [Table("F_GamesDetails")]
    public class F_GamesDetails
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 比赛编码
        /// </summary>
        /// <returns></returns>
        public string GameId { get; set; }
        /// <summary>
        /// 球员编码
        /// </summary>
        /// <returns></returns>
        public string PlayerId { get; set; }

        /// <summary>
        /// 描述
        /// </summary>
        /// <returns></returns>
        public string Describe { get; set; }
        /// <summary>
        /// 进球、防御等枚举
        /// </summary>
        /// <returns></returns>
        public string DetailType { get; set; }
        /// <summary>
        /// 分钟数
        /// </summary>
        /// <returns></returns>
        public int? Minutes { get; set; }
        /// <summary>
        /// 是否加时赛
        /// </summary>
        /// <returns></returns>
        public bool? IsHomeTeam { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 用以描述等扩充
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
    }
}