﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FCS.Models
{
    /// <summary>
    /// 积分榜
    /// </summary>
    [Table("F_IntegralRanking")]
    public class F_IntegralRanking
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 球队编码
        /// </summary>
        public string TeamId { get; set; }
        /// <summary>
        /// 积分类型
        /// </summary>
        public string IntegralRankingType { get; set; }
        /// <summary>
        /// 赛事类型
        /// </summary>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事
        /// </summary>
        public string EventId { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        public string Season { get; set; }
        /// <summary>
        /// 分组
        /// </summary>
        public string GroupingId { get; set; }
        /// <summary>
        /// 赛
        /// </summary>
        public string Game { get; set; }
        /// <summary>
        /// 胜
        /// </summary>
        public int Win { get; set; }
        /// <summary>
        /// 平
        /// </summary>
        public int Flat { get; set; }
        /// <summary>
        /// 负
        /// </summary>
        public int Lose { get; set; }
        /// <summary>
        /// 得
        /// </summary>
        public int Score { get; set; }
        /// <summary>
        /// 失
        /// </summary>
        public int Loss { get; set; }
        /// <summary>
        /// 净
        /// </summary>
        public int NetScore { get; set; }
        /// <summary>
        /// 胜率
        /// </summary>
        public double WinRate { get; set; }
        /// <summary>
        /// 平率
        /// </summary>
        public double FlatRate { get; set; }
        /// <summary>
        /// 负率
        /// </summary>
        public double LoseRate { get; set; }
        /// <summary>
        /// 均得
        /// </summary>
        public double ScoreAvg { get; set; }
        /// <summary>
        /// 均失
        /// </summary>
        public double LossAvg { get; set; }
        /// <summary>
        /// 近六轮
        /// </summary>
        public string NearlySix { get; set; }
        /// <summary>
        /// 积分
        /// </summary>
        public double Integral { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreateDateTime { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        public int Sort { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }
}
