﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FCS.Models
{
    /// <summary>
    /// 让球盘路model
    /// </summary>
    [Table("F_MakeBallList")]
    public class F_MakeBallList
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// 球队编码
        /// </summary>
        public string TeamId { get; set; }
        /// <summary>
        /// 赛事类型
        /// </summary>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事
        /// </summary>
        public string EventId { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        public string Season { get; set; }
        /// <summary>
        /// 让球类型
        /// </summary>
        public string MakeBallType { get; set; }
        /// <summary>
        /// 总比赛数
        /// </summary>
        public int Sum { get; set; }
        /// <summary>
        /// 上盘数
        /// </summary>
        public int UpDisc { get; set; }
        /// <summary>
        /// 平盘数
        /// </summary>
        public int FlatDisc { get; set; }
        /// <summary>
        /// 下盘数
        /// </summary>
        public int DownDisc { get; set; }
        /// <summary>
        /// 赢盘数
        /// </summary>
        public int WinDiscNum { get; set; }
        /// <summary>
        /// 走盘数
        /// </summary>
        public int GoDiscNum { get; set; }
        /// <summary>
        /// 输盘数
        /// </summary>
        public int TransportDiscNum { get; set; }
        /// <summary>
        /// 净盘数
        /// </summary>
        public int NetDiscNum { get; set; }
        /// <summary>
        /// 胜%
        /// </summary>
        public double WinPercentage { get; set; }
        /// <summary>
        /// 走%
        /// </summary>
        public double GoPercentage { get; set; }
        /// <summary>
        /// 负%
        /// </summary>
        public double NegativePercentage { get; set; }
        /// <summary>
        /// 排名
        /// </summary>
        public int Sort { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }

        /// <summary>
        /// 近六轮赛果
        /// </summary>
        public string SixRounds { get; set; }

        /// <summary>
        /// 近六轮赛果
        /// </summary>
        public DateTime CreateDateTime { get; set; } = DateTime.Now;
    }
}
