﻿using System;

namespace FCS.Models
{
    //F_OddsCuring
    /// <summary>
    /// 欧赔固化
    /// </summary>
    [Table("F_OddsCuring")]
    public class F_OddsCuring
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 初始赔率——胜
        /// </summary>
        /// <returns></returns>
        public double? Init_SOdd { get; set; }
        /// <summary>
        /// 初始赔率——平
        /// </summary>
        /// <returns></returns>
        public double? Init_POdd { get; set; }
        /// <summary>
        /// 初始赔率——负
        /// </summary>
        /// <returns></returns>
        public double? Init_FOdd { get; set; }
        /// <summary>
        /// 最新赔率——胜
        /// </summary>
        /// <returns></returns>
        public double? Newest_SOdd { get; set; }
        /// <summary>
        /// 最新赔率——平
        /// </summary>
        /// <returns></returns>
        public double? Newest_POdd { get; set; }
        /// <summary>
        /// 最新赔率——负
        /// </summary>
        /// <returns></returns>
        public double? Newest_FOdd { get; set; }
        /// <summary>
        /// 最新概率——主
        /// </summary>
        /// <returns></returns>
        public double? Probability_SOdd { get; set; }
        /// <summary>
        /// 最新概率——平
        /// </summary>
        /// <returns></returns>
        public double? Probability_POdd { get; set; }
        /// <summary>
        /// 最新概率——客
        /// </summary>
        /// <returns></returns>
        public double? Probability_FOdd { get; set; }
        /// <summary>
        /// 最新凯利指数——主
        /// </summary>
        /// <returns></returns>
        public double? Kelly_SOdd { get; set; }
        /// <summary>
        /// 最新凯利指数——平
        /// </summary>
        /// <returns></returns>
        public double? Kelly_POdd { get; set; }
        /// <summary>
        /// 最新凯利指数——客
        /// </summary>
        /// <returns></returns>
        public double? Kelly_FOdd { get; set; }
        /// <summary>
        /// 赔付率
        /// </summary>
        /// <returns></returns>
        public double? Loss_Odd { get; set; }
        /// <summary>
        /// 盘口公司编码
        /// </summary>
        /// <returns></returns>
        public string BankerCompanyId { get; set; }
        /// <summary>
        /// 盘口公司名称
        /// </summary>
        /// <returns></returns>
        public string BankerCompanyName { get; set; }
        /// <summary>
        /// 主队编码
        /// </summary>
        /// <returns></returns>
        public string HomeTeamId { get; set; }
        /// <summary>
        /// 主队名称
        /// </summary>
        /// <returns></returns>
        public string HomeTeamName { get; set; }
        /// <summary>
        /// 客队编码
        /// </summary>
        /// <returns></returns>
        public string VisitingTeamId { get; set; }
        /// <summary>
        /// 客队名称
        /// </summary>
        /// <returns></returns>
        public string VisitingTeamName { get; set; }
        /// <summary>
        /// 比赛编码
        /// </summary>
        /// <returns></returns>
        public string GameId { get; set; }
        /// <summary>
        /// 变化时间
        /// </summary>
        /// <returns></returns>
        public DateTime? ChangeDateTime { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
    }
}