﻿using System;

namespace FCS.Models
{
    //记录队员的转会信息
    public class F_PlayersTransfer
    {
        /// <summary>
        /// 编码ID
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 球员编码
        /// </summary>
        public string PlayersId { get; set; }

        /// <summary>
        /// 转会赛季
        /// </summary>
        public string Season { get; set; }

        /// <summary>
        /// 转会时间
        /// </summary>
        public DateTime DateTime { get; set; }

        /// <summary>
        /// 合同到期时间
        /// </summary>
        public DateTime ContractDateTime { get; set; }

        /// <summary>
        /// 来自球队编码
        /// </summary>
        public string FromTeamId { get; set; }

        /// <summary>
        /// 去向球队编码
        /// </summary>
        public string ToTeamId { get; set; }

        /// <summary>
        /// 转会费
        /// </summary>
        public decimal Money { get; set; }

        /// <summary>
        /// 类型(枚举)，续约等
        /// </summary>
        public string TransferType { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }
}