﻿using System;

namespace FCS.Models
{
    //足球球队与球员关系，可能是1个球员效力多个球队
    [Table("F_Relation")]
    public class F_Relation
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 球队编码
        /// </summary>
        public string TeamId { get; set; }

        /// <summary>
        /// 球员编码
        /// </summary>
        public string PlayerId { get; set; }

        /// <summary>
        /// 职位（枚举）
        /// </summary>
        public string Position { get; set; }

        /// <summary>
        /// 球衣
        /// </summary>
        public int PoloShirt { get; set; }

        /// <summary>
        /// 身价
        /// </summary>
        public string Worth { get; set; }

        /// <summary>
        /// 合同时间
        /// </summary>
        public DateTime ContractTime { get; set; }

        /// <summary>
        /// 首发次数/进球
        /// </summary>
        public string Starting_TimesAssist { get; set; }

        /// <summary>
        /// 替补次数/进球
        /// </summary>
        public string Substitute_TimesAssist { get; set; }

        /// <summary>
        /// 助攻
        /// </summary>
        public int Assist { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreateDateTime { get; set; }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
    }
}