﻿using System;

namespace FCS.Models
{
    //F_Compensate
    /// <summary>
    /// 赛季分析
    /// </summary>
    [Table("F_SeasonAnalysis")]
    public class F_SeasonAnalysis
    {
        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// 球队编码
        /// </summary>
        /// <returns></returns>
        public string TeamId { get; set; }
        /// <summary>
        /// 上赛季排名
        /// </summary>
        /// <returns></returns>
        public int? OldRanking { get; set; }
        /// <summary>
        /// 本赛季排名
        /// </summary>
        /// <returns></returns>
        public int? NowOldRanking { get; set; }
        /// <summary>
        /// 胜
        /// </summary>
        /// <returns></returns>
        public int? Win { get; set; }
        /// <summary>
        /// 平
        /// </summary>
        /// <returns></returns>
        public int? Draw { get; set; }
        /// <summary>
        /// 负
        /// </summary>
        /// <returns></returns>
        public int? Lose { get; set; }
        /// <summary>
        /// 分
        /// </summary>
        /// <returns></returns>
        public int? Number { get; set; }
        /// <summary>
        /// true：主对，false：客队
        /// </summary>
        /// <returns></returns>
        public bool? IsHome { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        /// <returns></returns>
        public string Season { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        /// <returns></returns>
        public DateTime? CreateDateTime { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        /// <returns></returns>
        public string Remark { get; set; }
    }
}