﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FCS.Models
{
    /// <summary>
    /// 射手榜
    /// </summary>
    [Table("F_ShooterList")]
    public class F_ShooterList
    {

        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// 球队编码
        /// </summary>
        public string TeamId { get; set; }
        /// <summary>
        /// 赛事类型
        /// </summary>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事
        /// </summary>
        public string EventId { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        public string Season { get; set; }
        /// <summary>
        /// 类型
        /// </summary>
        public string ShooterType { get; set; }

        /// <summary>
        /// 球员id
        /// </summary>
        public string PlayerId { get; set; }

        /// <summary>
        /// 球员name
        /// </summary>
        public string PlayerName { get; set; }

        /// <summary>
        /// 国家id
        /// </summary>
        public string ContryId { get; set; }

        /// <summary>
        /// 国家name
        /// </summary>
        public string ContryName { get; set; }

        /// <summary>
        /// 总进球
        /// </summary>
        public int Sum { get; set; }

        /// <summary>
        /// 点球
        /// </summary>
        public int PenaltyKick { get; set; }

        /// <summary>
        /// 主场进球
        /// </summary>
        public int HomeGoal { get; set; }

        /// <summary>
        /// 客场进球
        /// </summary>
        public int PassengerGoal { get; set; }

        /// <summary>
        /// 排序
        /// </summary>
        public int Sort { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreateDateTime { get; set; } = DateTime.Now;
    }
}
