﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FCS.Models
{
    /// <summary>
    /// 进球单双表
    /// </summary>
    [Table("F_SingleDoubleList")]
    public class F_SingleDoubleList
    {

        /// <summary>
        /// 编码Int
        /// </summary>
        public int PK { get; set; }

        /// <summary>
        /// 编码Guid
        /// </summary>
        public string Id { get; set; }
        /// <summary>
        /// 球队编码
        /// </summary>
        public string TeamId { get; set; }
        /// <summary>
        /// 赛事类型
        /// </summary>
        public string EventType { get; set; }
        /// <summary>
        /// 赛事
        /// </summary>
        public string EventId { get; set; }
        /// <summary>
        /// 赛季
        /// </summary>
        public string Season { get; set; }

        /// <summary>
        /// 0到1球
        /// </summary>
        public int ZeroNum { get; set; }

        /// <summary>
        /// 2到3球
        /// </summary>
        public int OneNum { get; set; }

        /// <summary>
        /// 4到6球
        /// </summary>
        public int TwoNum { get; set; }

        /// <summary>
        /// 7+球
        /// </summary>
        public int ThreeNum { get; set; }

        /// <summary>
        /// 总进球
        /// </summary>
        public int FourNum { get; set; }


        /// <summary>
        /// 单数
        /// </summary>
        public int OddNum { get; set; }
        /// <summary>
        /// 双数
        /// </summary>
        public int EvenNum { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        public int Sort { get; set; }


        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }


        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime CreateDateTime { get; set; } = DateTime.Now;
    }
}

